package com.mysql.jdbc;

import java.io.InputStream;
import java.io.Reader;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.Constructor;
import java.math.BigDecimal;
import java.net.URL;
import java.sql.Array;
import java.sql.Date;
import java.sql.ParameterMetaData;
import java.sql.Ref;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

/* loaded from: com_mysql_jdbc.jar:com/mysql/jdbc/CallableStatement.class */
public class CallableStatement extends PreparedStatement implements java.sql.CallableStatement {
    protected static final Constructor JDBC_4_CSTMT_2_ARGS_CTOR;
    protected static final Constructor JDBC_4_CSTMT_4_ARGS_CTOR;
    private static final int NOT_OUTPUT_PARAMETER_INDICATOR = Integer.MIN_VALUE;
    private static final String PARAMETER_NAMESPACE_PREFIX = "@com_mysql_jdbc_outparam_";
    private boolean callingStoredFunction;
    private ResultSetInternalMethods functionReturnValueResults;
    private boolean hasOutputParams;
    private ResultSetInternalMethods outputParameterResults;
    protected boolean outputParamWasNull;
    private int[] parameterIndexToRsIndex;
    protected CallableStatementParamInfo paramInfo;
    private CallableStatementParam returnValueParam;
    private int[] placeholderToParameterIndexMap;
    static Class class$com$mysql$jdbc$ConnectionImpl;
    static Class class$com$mysql$jdbc$CallableStatement$CallableStatementParamInfo;
    static Class class$java$lang$String;

    static {
        Class<?> cls;
        Class<?> cls2;
        Class<?> cls3;
        Class<?> cls4;
        Class<?> cls5;
        if (Util.isJdbc4()) {
            try {
                Class<?> cls6 = Class.forName("com.mysql.jdbc.JDBC4CallableStatement");
                Class<?>[] clsArr = new Class[2];
                if (class$com$mysql$jdbc$ConnectionImpl == null) {
                    cls = class$("com.mysql.jdbc.ConnectionImpl");
                    class$com$mysql$jdbc$ConnectionImpl = cls;
                } else {
                    cls = class$com$mysql$jdbc$ConnectionImpl;
                }
                clsArr[0] = cls;
                if (class$com$mysql$jdbc$CallableStatement$CallableStatementParamInfo == null) {
                    cls2 = class$("com.mysql.jdbc.CallableStatement$CallableStatementParamInfo");
                    class$com$mysql$jdbc$CallableStatement$CallableStatementParamInfo = cls2;
                } else {
                    cls2 = class$com$mysql$jdbc$CallableStatement$CallableStatementParamInfo;
                }
                clsArr[1] = cls2;
                JDBC_4_CSTMT_2_ARGS_CTOR = cls6.getConstructor(clsArr);
                Class<?> cls7 = Class.forName("com.mysql.jdbc.JDBC4CallableStatement");
                Class<?>[] clsArr2 = new Class[4];
                if (class$com$mysql$jdbc$ConnectionImpl == null) {
                    cls3 = class$("com.mysql.jdbc.ConnectionImpl");
                    class$com$mysql$jdbc$ConnectionImpl = cls3;
                } else {
                    cls3 = class$com$mysql$jdbc$ConnectionImpl;
                }
                clsArr2[0] = cls3;
                if (class$java$lang$String == null) {
                    cls4 = class$("java.lang.String");
                    class$java$lang$String = cls4;
                } else {
                    cls4 = class$java$lang$String;
                }
                clsArr2[1] = cls4;
                if (class$java$lang$String == null) {
                    cls5 = class$("java.lang.String");
                    class$java$lang$String = cls5;
                } else {
                    cls5 = class$java$lang$String;
                }
                clsArr2[2] = cls5;
                clsArr2[3] = Boolean.TYPE;
                JDBC_4_CSTMT_4_ARGS_CTOR = cls7.getConstructor(clsArr2);
                return;
            } catch (ClassNotFoundException e) {
                throw new RuntimeException(e);
            } catch (NoSuchMethodException e2) {
                throw new RuntimeException(e2);
            } catch (SecurityException e3) {
                throw new RuntimeException(e3);
            }
        }
        JDBC_4_CSTMT_4_ARGS_CTOR = null;
        JDBC_4_CSTMT_2_ARGS_CTOR = null;
    }

    static Class class$(String x0) {
        try {
            return Class.forName(x0);
        } catch (ClassNotFoundException x1) {
            throw new NoClassDefFoundError(x1.getMessage());
        }
    }

    /* JADX INFO: Access modifiers changed from: protected */
    /* loaded from: com_mysql_jdbc.jar:com/mysql/jdbc/CallableStatement$CallableStatementParam.class */
    public class CallableStatementParam {
        int desiredJdbcType;
        int index;
        int inOutModifier;
        boolean isIn;
        boolean isOut;
        int jdbcType;
        short nullability;
        String paramName;
        int precision;
        int scale;
        String typeName;
        private final CallableStatement this$0;

        CallableStatementParam(CallableStatement this$0, String name, int idx, boolean in, boolean out, int jdbcType, String typeName, int precision, int scale, short nullability, int inOutModifier) {
            this.this$0 = this$0;
            this.paramName = name;
            this.isIn = in;
            this.isOut = out;
            this.index = idx;
            this.jdbcType = jdbcType;
            this.typeName = typeName;
            this.precision = precision;
            this.scale = scale;
            this.nullability = nullability;
            this.inOutModifier = inOutModifier;
        }

        protected Object clone() throws CloneNotSupportedException {
            return super.clone();
        }
    }

    /* JADX INFO: Access modifiers changed from: protected */
    /* loaded from: com_mysql_jdbc.jar:com/mysql/jdbc/CallableStatement$CallableStatementParamInfo.class */
    public class CallableStatementParamInfo {
        String catalogInUse;
        boolean isFunctionCall;
        String nativeSql;
        int numParameters;
        List parameterList;
        Map parameterMap;
        private final CallableStatement this$0;

        CallableStatementParamInfo(CallableStatement this$0, CallableStatementParamInfo fullParamInfo) {
            this.this$0 = this$0;
            this.nativeSql = this$0.originalSql;
            this.catalogInUse = this$0.currentCatalog;
            this.isFunctionCall = fullParamInfo.isFunctionCall;
            int[] localParameterMap = this$0.placeholderToParameterIndexMap;
            int parameterMapLength = localParameterMap.length;
            this.parameterList = new ArrayList(fullParamInfo.numParameters);
            this.parameterMap = new HashMap(fullParamInfo.numParameters);
            if (this.isFunctionCall) {
                this.parameterList.add(fullParamInfo.parameterList.get(0));
            }
            int offset = this.isFunctionCall ? 1 : 0;
            for (int i = 0; i < parameterMapLength; i++) {
                if (localParameterMap[i] != 0) {
                    CallableStatementParam param = (CallableStatementParam) fullParamInfo.parameterList.get(localParameterMap[i] + offset);
                    this.parameterList.add(param);
                    this.parameterMap.put(param.paramName, param);
                }
            }
            this.numParameters = this.parameterList.size();
        }

        CallableStatementParamInfo(CallableStatement this$0, ResultSet paramTypesRs) throws SQLException {
            this.this$0 = this$0;
            boolean hadRows = paramTypesRs.last();
            this.nativeSql = this$0.originalSql;
            this.catalogInUse = this$0.currentCatalog;
            this.isFunctionCall = this$0.callingStoredFunction;
            if (hadRows) {
                this.numParameters = paramTypesRs.getRow();
                this.parameterList = new ArrayList(this.numParameters);
                this.parameterMap = new HashMap(this.numParameters);
                paramTypesRs.beforeFirst();
                addParametersFromDBMD(paramTypesRs);
            } else {
                this.numParameters = 0;
            }
            if (this.isFunctionCall) {
                this.numParameters++;
            }
        }

        private void addParametersFromDBMD(ResultSet paramTypesRs) throws SQLException {
            int i = 0;
            while (paramTypesRs.next()) {
                String paramName = paramTypesRs.getString(4);
                int inOutModifier = paramTypesRs.getInt(5);
                boolean isOutParameter = false;
                boolean isInParameter = false;
                if (i == 0 && this.isFunctionCall) {
                    isOutParameter = true;
                    isInParameter = false;
                } else if (inOutModifier == 2) {
                    isOutParameter = true;
                    isInParameter = true;
                } else if (inOutModifier == 1) {
                    isOutParameter = false;
                    isInParameter = true;
                } else if (inOutModifier == 4) {
                    isOutParameter = true;
                    isInParameter = false;
                }
                int jdbcType = paramTypesRs.getInt(6);
                String typeName = paramTypesRs.getString(7);
                int precision = paramTypesRs.getInt(8);
                int scale = paramTypesRs.getInt(10);
                short nullability = paramTypesRs.getShort(12);
                int i2 = i;
                i++;
                CallableStatementParam paramInfoToAdd = new CallableStatementParam(this.this$0, paramName, i2, isInParameter, isOutParameter, jdbcType, typeName, precision, scale, nullability, inOutModifier);
                this.parameterList.add(paramInfoToAdd);
                this.parameterMap.put(paramName, paramInfoToAdd);
            }
        }

        protected void checkBounds(int paramIndex) throws SQLException {
            int localParamIndex = paramIndex - 1;
            if (paramIndex < 0 || localParamIndex >= this.numParameters) {
                throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("CallableStatement.11")).append(paramIndex).append(Messages.getString("CallableStatement.12")).append(this.numParameters).append(Messages.getString("CallableStatement.13")).toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
            }
        }

        protected Object clone() throws CloneNotSupportedException {
            return super.clone();
        }

        CallableStatementParam getParameter(int index) {
            return (CallableStatementParam) this.parameterList.get(index);
        }

        CallableStatementParam getParameter(String name) {
            return (CallableStatementParam) this.parameterMap.get(name);
        }

        public String getParameterClassName(int arg0) throws SQLException {
            String mysqlTypeName = getParameterTypeName(arg0);
            boolean isBinaryOrBlob = (StringUtils.indexOfIgnoreCase(mysqlTypeName, "BLOB") == -1 && StringUtils.indexOfIgnoreCase(mysqlTypeName, "BINARY") == -1) ? false : true;
            boolean isUnsigned = StringUtils.indexOfIgnoreCase(mysqlTypeName, "UNSIGNED") != -1;
            int mysqlTypeIfKnown = 0;
            if (StringUtils.startsWithIgnoreCase(mysqlTypeName, "MEDIUMINT")) {
                mysqlTypeIfKnown = 9;
            }
            return ResultSetMetaData.getClassNameForJavaType(getParameterType(arg0), isUnsigned, mysqlTypeIfKnown, isBinaryOrBlob, false);
        }

        public int getParameterCount() throws SQLException {
            if (this.parameterList == null) {
                return 0;
            }
            return this.parameterList.size();
        }

        public int getParameterMode(int arg0) throws SQLException {
            checkBounds(arg0);
            return getParameter(arg0 - 1).inOutModifier;
        }

        public int getParameterType(int arg0) throws SQLException {
            checkBounds(arg0);
            return getParameter(arg0 - 1).jdbcType;
        }

        public String getParameterTypeName(int arg0) throws SQLException {
            checkBounds(arg0);
            return getParameter(arg0 - 1).typeName;
        }

        public int getPrecision(int arg0) throws SQLException {
            checkBounds(arg0);
            return getParameter(arg0 - 1).precision;
        }

        public int getScale(int arg0) throws SQLException {
            checkBounds(arg0);
            return getParameter(arg0 - 1).scale;
        }

        public int isNullable(int arg0) throws SQLException {
            checkBounds(arg0);
            return getParameter(arg0 - 1).nullability;
        }

        public boolean isSigned(int arg0) throws SQLException {
            checkBounds(arg0);
            return false;
        }

        Iterator iterator() {
            return this.parameterList.iterator();
        }

        int numberOfParameters() {
            return this.numParameters;
        }
    }

    /* JADX INFO: Access modifiers changed from: protected */
    /* loaded from: com_mysql_jdbc.jar:com/mysql/jdbc/CallableStatement$CallableStatementParamInfoJDBC3.class */
    public class CallableStatementParamInfoJDBC3 extends CallableStatementParamInfo implements ParameterMetaData {
        private final CallableStatement this$0;

        CallableStatementParamInfoJDBC3(CallableStatement this$0, ResultSet paramTypesRs) throws SQLException {
            super(this$0, paramTypesRs);
            this.this$0 = this$0;
        }

        public CallableStatementParamInfoJDBC3(CallableStatement this$0, CallableStatementParamInfo paramInfo) {
            super(this$0, paramInfo);
            this.this$0 = this$0;
        }

        @Override // java.sql.Wrapper
        public boolean isWrapperFor(Class iface) throws SQLException {
            this.this$0.checkClosed();
            return iface.isInstance(this);
        }

        @Override // java.sql.Wrapper
        public Object unwrap(Class iface) throws SQLException {
            try {
                return Util.cast(iface, this);
            } catch (ClassCastException e) {
                throw SQLError.createSQLException(new StringBuffer().append("Unable to unwrap to ").append(iface.toString()).toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
            }
        }
    }

    private static String mangleParameterName(String origParameterName) {
        if (origParameterName == null) {
            return null;
        }
        int offset = 0;
        if (origParameterName.length() > 0 && origParameterName.charAt(0) == '@') {
            offset = 1;
        }
        StringBuffer paramNameBuf = new StringBuffer(PARAMETER_NAMESPACE_PREFIX.length() + origParameterName.length());
        paramNameBuf.append(PARAMETER_NAMESPACE_PREFIX);
        paramNameBuf.append(origParameterName.substring(offset));
        return paramNameBuf.toString();
    }

    public CallableStatement(ConnectionImpl conn, CallableStatementParamInfo paramInfo) throws SQLException {
        super(conn, paramInfo.nativeSql, paramInfo.catalogInUse);
        this.callingStoredFunction = false;
        this.hasOutputParams = false;
        this.outputParamWasNull = false;
        this.paramInfo = paramInfo;
        this.callingStoredFunction = this.paramInfo.isFunctionCall;
        if (this.callingStoredFunction) {
            this.parameterCount++;
        }
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public static CallableStatement getInstance(ConnectionImpl conn, String sql, String catalog, boolean isFunctionCall) throws SQLException {
        return !Util.isJdbc4() ? new CallableStatement(conn, sql, catalog, isFunctionCall) : (CallableStatement) Util.handleNewInstance(JDBC_4_CSTMT_4_ARGS_CTOR, new Object[]{conn, sql, catalog, Boolean.valueOf(isFunctionCall)});
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public static CallableStatement getInstance(ConnectionImpl conn, CallableStatementParamInfo paramInfo) throws SQLException {
        return !Util.isJdbc4() ? new CallableStatement(conn, paramInfo) : (CallableStatement) Util.handleNewInstance(JDBC_4_CSTMT_2_ARGS_CTOR, new Object[]{conn, paramInfo});
    }

    private void generateParameterMap() throws SQLException {
        int parenOpenPos;
        int parenClosePos;
        if (this.paramInfo == null) {
            return;
        }
        int parameterCountFromMetaData = this.paramInfo.getParameterCount();
        if (this.callingStoredFunction) {
            parameterCountFromMetaData--;
        }
        if (this.paramInfo != null && this.parameterCount != parameterCountFromMetaData) {
            this.placeholderToParameterIndexMap = new int[this.parameterCount];
            int startPos = this.callingStoredFunction ? StringUtils.indexOfIgnoreCase(this.originalSql, "SELECT") : StringUtils.indexOfIgnoreCase(this.originalSql, "CALL");
            if (startPos != -1 && (parenOpenPos = this.originalSql.indexOf(40, startPos + 4)) != -1 && (parenClosePos = StringUtils.indexOfIgnoreCaseRespectQuotes(parenOpenPos, this.originalSql, ")", '\'', true)) != -1) {
                List parsedParameters = StringUtils.split(this.originalSql.substring(parenOpenPos + 1, parenClosePos), ",", "'\"", "'\"", true);
                int numParsedParameters = parsedParameters.size();
                if (numParsedParameters != this.parameterCount) {
                }
                int placeholderCount = 0;
                for (int i = 0; i < numParsedParameters; i++) {
                    if (((String) parsedParameters.get(i)).equals("?")) {
                        int i2 = placeholderCount;
                        placeholderCount++;
                        this.placeholderToParameterIndexMap[i2] = i;
                    }
                }
            }
        }
    }

    public CallableStatement(ConnectionImpl conn, String sql, String catalog, boolean isFunctionCall) throws SQLException {
        super(conn, sql, catalog);
        this.callingStoredFunction = false;
        this.hasOutputParams = false;
        this.outputParamWasNull = false;
        this.callingStoredFunction = isFunctionCall;
        determineParameterTypes();
        generateParameterMap();
        if (this.callingStoredFunction) {
            this.parameterCount++;
        }
    }

    @Override // com.mysql.jdbc.PreparedStatement, java.sql.PreparedStatement
    public void addBatch() throws SQLException {
        setOutParams();
        super.addBatch();
    }

    private CallableStatementParam checkIsOutputParam(int paramIndex) throws SQLException {
        if (this.callingStoredFunction) {
            if (paramIndex == 1) {
                if (this.returnValueParam == null) {
                    this.returnValueParam = new CallableStatementParam(this, "", 0, false, true, 12, "VARCHAR", 0, 0, (short) 2, 5);
                }
                return this.returnValueParam;
            }
            paramIndex--;
        }
        checkParameterIndexBounds(paramIndex);
        int localParamIndex = paramIndex - 1;
        if (this.placeholderToParameterIndexMap != null) {
            localParamIndex = this.placeholderToParameterIndexMap[localParamIndex];
        }
        CallableStatementParam paramDescriptor = this.paramInfo.getParameter(localParamIndex);
        if (!paramDescriptor.isOut) {
            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("CallableStatement.9")).append(paramIndex).append(Messages.getString("CallableStatement.10")).toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        this.hasOutputParams = true;
        return paramDescriptor;
    }

    private void checkParameterIndexBounds(int paramIndex) throws SQLException {
        this.paramInfo.checkBounds(paramIndex);
    }

    private void checkStreamability() throws SQLException {
        if (this.hasOutputParams && createStreamingResultSet()) {
            throw SQLError.createSQLException(Messages.getString("CallableStatement.14"), SQLError.SQL_STATE_DRIVER_NOT_CAPABLE);
        }
    }

    @Override // com.mysql.jdbc.PreparedStatement, java.sql.PreparedStatement
    public synchronized void clearParameters() throws SQLException {
        super.clearParameters();
        try {
            if (this.outputParameterResults != null) {
                this.outputParameterResults.close();
            }
        } finally {
            this.outputParameterResults = null;
        }
    }

    /* JADX WARN: Multi-variable type inference failed */
    private void fakeParameterTypes() throws SQLException {
        byte[] procNameAsBytes;
        Field[] fields = {new Field("", "PROCEDURE_CAT", 1, 0), new Field("", "PROCEDURE_SCHEM", 1, 0), new Field("", "PROCEDURE_NAME", 1, 0), new Field("", "COLUMN_NAME", 1, 0), new Field("", "COLUMN_TYPE", 1, 0), new Field("", "DATA_TYPE", 5, 0), new Field("", "TYPE_NAME", 1, 0), new Field("", "PRECISION", 4, 0), new Field("", "LENGTH", 4, 0), new Field("", "SCALE", 5, 0), new Field("", "RADIX", 5, 0), new Field("", "NULLABLE", 5, 0), new Field("", "REMARKS", 1, 0)};
        String procName = extractProcedureName();
        try {
            procNameAsBytes = procName.getBytes("UTF-8");
        } catch (UnsupportedEncodingException e) {
            procNameAsBytes = StringUtils.s2b(procName, this.connection);
        }
        ArrayList resultRows = new ArrayList();
        for (int i = 0; i < this.parameterCount; i++) {
            resultRows.add(new byte[]{0, 0, procNameAsBytes, StringUtils.s2b(String.valueOf(i), this.connection), StringUtils.s2b(String.valueOf(2), this.connection), StringUtils.s2b(String.valueOf(12), this.connection), StringUtils.s2b("VARCHAR", this.connection), StringUtils.s2b(Integer.toString(65535), this.connection), StringUtils.s2b(Integer.toString(65535), this.connection), StringUtils.s2b(Integer.toString(0), this.connection), StringUtils.s2b(Integer.toString(10), this.connection), StringUtils.s2b(Integer.toString(2), this.connection), 0});
        }
        ResultSet paramTypesRs = DatabaseMetaData.buildResultSet(fields, resultRows, this.connection);
        convertGetProcedureColumnsToInternalDescriptors(paramTypesRs);
    }

    /*  JADX ERROR: JadxRuntimeException in pass: BlockProcessor
        jadx.core.utils.exceptions.JadxRuntimeException: Unreachable block: B:26:0x0078
        	at jadx.core.dex.visitors.blocks.BlockProcessor.checkForUnreachableBlocks(BlockProcessor.java:88)
        	at jadx.core.dex.visitors.blocks.BlockProcessor.processBlocksTree(BlockProcessor.java:52)
        	at jadx.core.dex.visitors.blocks.BlockProcessor.visit(BlockProcessor.java:44)
        */
    private void determineParameterTypes() throws java.sql.SQLException {
        /*
            r6 = this;
            r0 = r6
            com.mysql.jdbc.ConnectionImpl r0 = r0.connection
            boolean r0 = r0.getNoAccessToProcedureBodies()
            if (r0 == 0) goto Lf
            r0 = r6
            r0.fakeParameterTypes()
            return
        Lf:
            r0 = 0
            r7 = r0
            r0 = r6
            java.lang.String r0 = r0.extractProcedureName()     // Catch: java.lang.Throwable -> L5e
            r8 = r0
            r0 = r6
            com.mysql.jdbc.ConnectionImpl r0 = r0.connection     // Catch: java.lang.Throwable -> L5e
            java.sql.DatabaseMetaData r0 = r0.getMetaData()     // Catch: java.lang.Throwable -> L5e
            r9 = r0
            r0 = 0
            r10 = r0
            r0 = r8
            java.lang.String r1 = "."
            int r0 = r0.indexOf(r1)     // Catch: java.lang.Throwable -> L5e
            r1 = -1
            if (r0 != r1) goto L2e
            r0 = 1
            r10 = r0
        L2e:
            r0 = r9
            r1 = r6
            com.mysql.jdbc.ConnectionImpl r1 = r1.connection     // Catch: java.lang.Throwable -> L5e
            r2 = 5
            r3 = 0
            r4 = 2
            boolean r1 = r1.versionMeetsMinimum(r2, r3, r4)     // Catch: java.lang.Throwable -> L5e
            if (r1 == 0) goto L48
            r1 = r10
            if (r1 == 0) goto L48
            r1 = r6
            java.lang.String r1 = r1.currentCatalog     // Catch: java.lang.Throwable -> L5e
            goto L49
        L48:
            r1 = 0
        L49:
            r2 = 0
            r3 = r8
            java.lang.String r4 = "%"
            java.sql.ResultSet r0 = r0.getProcedureColumns(r1, r2, r3, r4)     // Catch: java.lang.Throwable -> L5e
            r7 = r0
            r0 = r6
            r1 = r7
            r0.convertGetProcedureColumnsToInternalDescriptors(r1)     // Catch: java.lang.Throwable -> L5e
            r0 = jsr -> L66
        L5b:
            goto L8a
        L5e:
            r11 = move-exception
            r0 = jsr -> L66
        L63:
            r1 = r11
            throw r1
        L66:
            r12 = r0
            r0 = 0
            r13 = r0
            r0 = r7
            if (r0 == 0) goto L80
            r0 = r7
            r0.close()     // Catch: java.sql.SQLException -> L78
            goto L7e
        L78:
            r14 = move-exception
            r0 = r14
            r13 = r0
        L7e:
            r0 = 0
            r7 = r0
        L80:
            r0 = r13
            if (r0 == 0) goto L88
            r0 = r13
            throw r0
        L88:
            ret r12
        L8a:
            return
        */
        throw new UnsupportedOperationException("Method not decompiled: com.mysql.jdbc.CallableStatement.determineParameterTypes():void");
    }

    private void convertGetProcedureColumnsToInternalDescriptors(ResultSet paramTypesRs) throws SQLException {
        if (!this.connection.isRunningOnJDK13()) {
            this.paramInfo = new CallableStatementParamInfoJDBC3(this, paramTypesRs);
        } else {
            this.paramInfo = new CallableStatementParamInfo(this, paramTypesRs);
        }
    }

    @Override // com.mysql.jdbc.PreparedStatement, java.sql.PreparedStatement
    public boolean execute() throws SQLException {
        boolean returnVal;
        checkClosed();
        checkStreamability();
        synchronized (this.connection.getMutex()) {
            setInOutParamsOnServer();
            setOutParams();
            returnVal = super.execute();
            if (this.callingStoredFunction) {
                this.functionReturnValueResults = this.results;
                this.functionReturnValueResults.next();
                this.results = null;
            }
            retrieveOutParams();
        }
        if (!this.callingStoredFunction) {
            return returnVal;
        }
        return false;
    }

    @Override // com.mysql.jdbc.PreparedStatement, java.sql.PreparedStatement
    public ResultSet executeQuery() throws SQLException {
        ResultSet execResults;
        checkClosed();
        checkStreamability();
        synchronized (this.connection.getMutex()) {
            setInOutParamsOnServer();
            setOutParams();
            execResults = super.executeQuery();
            retrieveOutParams();
        }
        return execResults;
    }

    @Override // com.mysql.jdbc.PreparedStatement, java.sql.PreparedStatement
    public int executeUpdate() throws SQLException {
        int returnVal;
        checkClosed();
        checkStreamability();
        if (this.callingStoredFunction) {
            execute();
            return -1;
        }
        synchronized (this.connection.getMutex()) {
            setInOutParamsOnServer();
            setOutParams();
            returnVal = super.executeUpdate();
            retrieveOutParams();
        }
        return returnVal;
    }

    private String extractProcedureName() throws SQLException {
        String sanitizedSql = StringUtils.stripComments(this.originalSql, "`\"'", "`\"'", true, false, true, true);
        int endCallIndex = StringUtils.indexOfIgnoreCase(sanitizedSql, "CALL ");
        int offset = 5;
        if (endCallIndex == -1) {
            endCallIndex = StringUtils.indexOfIgnoreCase(sanitizedSql, "SELECT ");
            offset = 7;
        }
        if (endCallIndex != -1) {
            StringBuffer nameBuf = new StringBuffer();
            String trimmedStatement = sanitizedSql.substring(endCallIndex + offset).trim();
            int statementLength = trimmedStatement.length();
            for (int i = 0; i < statementLength; i++) {
                char c = trimmedStatement.charAt(i);
                if (Character.isWhitespace(c) || c == '(' || c == '?') {
                    break;
                }
                nameBuf.append(c);
            }
            return nameBuf.toString();
        }
        throw SQLError.createSQLException(Messages.getString("CallableStatement.1"), SQLError.SQL_STATE_GENERAL_ERROR);
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public String fixParameterName(String paramNameIn) throws SQLException {
        if (paramNameIn == null || paramNameIn.length() == 0) {
            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("CallableStatement.0")).append(paramNameIn).toString() == null ? Messages.getString("CallableStatement.15") : Messages.getString("CallableStatement.16"), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        if (this.connection.getNoAccessToProcedureBodies()) {
            throw SQLError.createSQLException("No access to parameters by name when connection has been configured not to access procedure bodies", SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        return mangleParameterName(paramNameIn);
    }

    @Override // java.sql.CallableStatement
    public synchronized Array getArray(int i) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(i);
        Array retValue = rs.getArray(mapOutputParameterIndexToRsIndex(i));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized Array getArray(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        Array retValue = rs.getArray(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized BigDecimal getBigDecimal(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        BigDecimal retValue = rs.getBigDecimal(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized BigDecimal getBigDecimal(int parameterIndex, int scale) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        BigDecimal retValue = rs.getBigDecimal(mapOutputParameterIndexToRsIndex(parameterIndex), scale);
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized BigDecimal getBigDecimal(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        BigDecimal retValue = rs.getBigDecimal(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized java.sql.Blob getBlob(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        java.sql.Blob retValue = rs.getBlob(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized java.sql.Blob getBlob(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        java.sql.Blob retValue = rs.getBlob(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized boolean getBoolean(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        boolean retValue = rs.getBoolean(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized boolean getBoolean(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        boolean retValue = rs.getBoolean(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized byte getByte(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        byte retValue = rs.getByte(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized byte getByte(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        byte retValue = rs.getByte(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized byte[] getBytes(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        byte[] retValue = rs.getBytes(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized byte[] getBytes(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        byte[] retValue = rs.getBytes(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized java.sql.Clob getClob(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        java.sql.Clob retValue = rs.getClob(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized java.sql.Clob getClob(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        java.sql.Clob retValue = rs.getClob(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized Date getDate(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        Date retValue = rs.getDate(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized Date getDate(int parameterIndex, Calendar cal) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        Date retValue = rs.getDate(mapOutputParameterIndexToRsIndex(parameterIndex), cal);
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized Date getDate(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        Date retValue = rs.getDate(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized Date getDate(String parameterName, Calendar cal) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        Date retValue = rs.getDate(fixParameterName(parameterName), cal);
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized double getDouble(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        double retValue = rs.getDouble(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized double getDouble(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        double retValue = rs.getDouble(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized float getFloat(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        float retValue = rs.getFloat(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized float getFloat(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        float retValue = rs.getFloat(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized int getInt(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        int retValue = rs.getInt(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized int getInt(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        int retValue = rs.getInt(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized long getLong(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        long retValue = rs.getLong(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized long getLong(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        long retValue = rs.getLong(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public int getNamedParamIndex(String paramName, boolean forOut) throws SQLException {
        if (this.connection.getNoAccessToProcedureBodies()) {
            throw SQLError.createSQLException("No access to parameters by name when connection has been configured not to access procedure bodies", SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        if (paramName == null || paramName.length() == 0) {
            throw SQLError.createSQLException(Messages.getString("CallableStatement.2"), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        if (this.paramInfo == null) {
            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("CallableStatement.3")).append(paramName).append(Messages.getString("CallableStatement.4")).toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        CallableStatementParam namedParamInfo = this.paramInfo.getParameter(paramName);
        if (forOut && !namedParamInfo.isOut) {
            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("CallableStatement.5")).append(paramName).append(Messages.getString("CallableStatement.6")).toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        if (this.placeholderToParameterIndexMap == null) {
            return namedParamInfo.index + 1;
        }
        for (int i = 0; i < this.placeholderToParameterIndexMap.length; i++) {
            if (this.placeholderToParameterIndexMap[i] == namedParamInfo.index) {
                return i + 1;
            }
        }
        throw SQLError.createSQLException(new StringBuffer().append("Can't find local placeholder mapping for parameter named \"").append(paramName).append("\".").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
    }

    @Override // java.sql.CallableStatement
    public synchronized Object getObject(int parameterIndex) throws SQLException {
        CallableStatementParam paramDescriptor = checkIsOutputParam(parameterIndex);
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        Object retVal = rs.getObjectStoredProc(mapOutputParameterIndexToRsIndex(parameterIndex), paramDescriptor.desiredJdbcType);
        this.outputParamWasNull = rs.wasNull();
        return retVal;
    }

    @Override // java.sql.CallableStatement
    public synchronized Object getObject(int parameterIndex, Map map) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        Object retVal = rs.getObject(mapOutputParameterIndexToRsIndex(parameterIndex), (Map<String, Class<?>>) map);
        this.outputParamWasNull = rs.wasNull();
        return retVal;
    }

    @Override // java.sql.CallableStatement
    public synchronized Object getObject(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        Object retValue = rs.getObject(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized Object getObject(String parameterName, Map map) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        Object retValue = rs.getObject(fixParameterName(parameterName), (Map<String, Class<?>>) map);
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public ResultSetInternalMethods getOutputParameters(int paramIndex) throws SQLException {
        this.outputParamWasNull = false;
        if (paramIndex == 1 && this.callingStoredFunction && this.returnValueParam != null) {
            return this.functionReturnValueResults;
        }
        if (this.outputParameterResults == null) {
            if (this.paramInfo.numberOfParameters() == 0) {
                throw SQLError.createSQLException(Messages.getString("CallableStatement.7"), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
            }
            throw SQLError.createSQLException(Messages.getString("CallableStatement.8"), SQLError.SQL_STATE_GENERAL_ERROR);
        }
        return this.outputParameterResults;
    }

    @Override // com.mysql.jdbc.PreparedStatement, java.sql.PreparedStatement
    public synchronized ParameterMetaData getParameterMetaData() throws SQLException {
        if (this.placeholderToParameterIndexMap == null) {
            return (CallableStatementParamInfoJDBC3) this.paramInfo;
        }
        return new CallableStatementParamInfoJDBC3(this, this.paramInfo);
    }

    @Override // java.sql.CallableStatement
    public synchronized Ref getRef(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        Ref retValue = rs.getRef(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized Ref getRef(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        Ref retValue = rs.getRef(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized short getShort(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        short retValue = rs.getShort(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized short getShort(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        short retValue = rs.getShort(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized String getString(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        String retValue = rs.getString(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized String getString(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        String retValue = rs.getString(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized Time getTime(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        Time retValue = rs.getTime(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized Time getTime(int parameterIndex, Calendar cal) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        Time retValue = rs.getTime(mapOutputParameterIndexToRsIndex(parameterIndex), cal);
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized Time getTime(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        Time retValue = rs.getTime(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized Time getTime(String parameterName, Calendar cal) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        Time retValue = rs.getTime(fixParameterName(parameterName), cal);
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized Timestamp getTimestamp(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        Timestamp retValue = rs.getTimestamp(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized Timestamp getTimestamp(int parameterIndex, Calendar cal) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        Timestamp retValue = rs.getTimestamp(mapOutputParameterIndexToRsIndex(parameterIndex), cal);
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized Timestamp getTimestamp(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        Timestamp retValue = rs.getTimestamp(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized Timestamp getTimestamp(String parameterName, Calendar cal) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        Timestamp retValue = rs.getTimestamp(fixParameterName(parameterName), cal);
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized URL getURL(int parameterIndex) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(parameterIndex);
        URL retValue = rs.getURL(mapOutputParameterIndexToRsIndex(parameterIndex));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    @Override // java.sql.CallableStatement
    public synchronized URL getURL(String parameterName) throws SQLException {
        ResultSetInternalMethods rs = getOutputParameters(0);
        URL retValue = rs.getURL(fixParameterName(parameterName));
        this.outputParamWasNull = rs.wasNull();
        return retValue;
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public int mapOutputParameterIndexToRsIndex(int paramIndex) throws SQLException {
        if (this.returnValueParam != null && paramIndex == 1) {
            return 1;
        }
        checkParameterIndexBounds(paramIndex);
        int localParamIndex = paramIndex - 1;
        if (this.placeholderToParameterIndexMap != null) {
            localParamIndex = this.placeholderToParameterIndexMap[localParamIndex];
        }
        int rsIndex = this.parameterIndexToRsIndex[localParamIndex];
        if (rsIndex == NOT_OUTPUT_PARAMETER_INDICATOR) {
            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("CallableStatement.21")).append(paramIndex).append(Messages.getString("CallableStatement.22")).toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        return rsIndex + 1;
    }

    @Override // java.sql.CallableStatement
    public void registerOutParameter(int parameterIndex, int sqlType) throws SQLException {
        CallableStatementParam paramDescriptor = checkIsOutputParam(parameterIndex);
        paramDescriptor.desiredJdbcType = sqlType;
    }

    @Override // java.sql.CallableStatement
    public void registerOutParameter(int parameterIndex, int sqlType, int scale) throws SQLException {
        registerOutParameter(parameterIndex, sqlType);
    }

    @Override // java.sql.CallableStatement
    public void registerOutParameter(int parameterIndex, int sqlType, String typeName) throws SQLException {
        checkIsOutputParam(parameterIndex);
    }

    @Override // java.sql.CallableStatement
    public synchronized void registerOutParameter(String parameterName, int sqlType) throws SQLException {
        registerOutParameter(getNamedParamIndex(parameterName, true), sqlType);
    }

    @Override // java.sql.CallableStatement
    public void registerOutParameter(String parameterName, int sqlType, int scale) throws SQLException {
        registerOutParameter(getNamedParamIndex(parameterName, true), sqlType);
    }

    @Override // java.sql.CallableStatement
    public void registerOutParameter(String parameterName, int sqlType, String typeName) throws SQLException {
        registerOutParameter(getNamedParamIndex(parameterName, true), sqlType, typeName);
    }

    /* JADX WARN: Finally extract failed */
    private void retrieveOutParams() throws SQLException {
        int numParameters = this.paramInfo.numberOfParameters();
        this.parameterIndexToRsIndex = new int[numParameters];
        for (int i = 0; i < numParameters; i++) {
            this.parameterIndexToRsIndex[i] = NOT_OUTPUT_PARAMETER_INDICATOR;
        }
        int localParamIndex = 0;
        if (numParameters > 0) {
            StringBuffer outParameterQuery = new StringBuffer("SELECT ");
            boolean firstParam = true;
            boolean hadOutputParams = false;
            Iterator paramIter = this.paramInfo.iterator();
            while (paramIter.hasNext()) {
                CallableStatementParam retrParamInfo = (CallableStatementParam) paramIter.next();
                if (retrParamInfo.isOut) {
                    hadOutputParams = true;
                    int i2 = localParamIndex;
                    localParamIndex++;
                    this.parameterIndexToRsIndex[retrParamInfo.index] = i2;
                    String outParameterName = mangleParameterName(retrParamInfo.paramName);
                    if (!firstParam) {
                        outParameterQuery.append(",");
                    } else {
                        firstParam = false;
                    }
                    if (!outParameterName.startsWith("@")) {
                        outParameterQuery.append('@');
                    }
                    outParameterQuery.append(outParameterName);
                }
            }
            if (hadOutputParams) {
                java.sql.Statement outParameterStmt = null;
                try {
                    outParameterStmt = this.connection.createStatement();
                    ResultSet outParamRs = outParameterStmt.executeQuery(outParameterQuery.toString());
                    this.outputParameterResults = ((ResultSetInternalMethods) outParamRs).copy();
                    if (!this.outputParameterResults.next()) {
                        this.outputParameterResults.close();
                        this.outputParameterResults = null;
                    }
                    if (outParameterStmt != null) {
                        outParameterStmt.close();
                        return;
                    }
                    return;
                } catch (Throwable th) {
                    if (outParameterStmt != null) {
                        outParameterStmt.close();
                    }
                    throw th;
                }
            }
            this.outputParameterResults = null;
            return;
        }
        this.outputParameterResults = null;
    }

    @Override // java.sql.CallableStatement
    public void setAsciiStream(String parameterName, InputStream x, int length) throws SQLException {
        setAsciiStream(getNamedParamIndex(parameterName, false), x, length);
    }

    @Override // java.sql.CallableStatement
    public void setBigDecimal(String parameterName, BigDecimal x) throws SQLException {
        setBigDecimal(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setBinaryStream(String parameterName, InputStream x, int length) throws SQLException {
        setBinaryStream(getNamedParamIndex(parameterName, false), x, length);
    }

    @Override // java.sql.CallableStatement
    public void setBoolean(String parameterName, boolean x) throws SQLException {
        setBoolean(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setByte(String parameterName, byte x) throws SQLException {
        setByte(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setBytes(String parameterName, byte[] x) throws SQLException {
        setBytes(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setCharacterStream(String parameterName, Reader reader, int length) throws SQLException {
        setCharacterStream(getNamedParamIndex(parameterName, false), reader, length);
    }

    @Override // java.sql.CallableStatement
    public void setDate(String parameterName, Date x) throws SQLException {
        setDate(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setDate(String parameterName, Date x, Calendar cal) throws SQLException {
        setDate(getNamedParamIndex(parameterName, false), x, cal);
    }

    @Override // java.sql.CallableStatement
    public void setDouble(String parameterName, double x) throws SQLException {
        setDouble(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setFloat(String parameterName, float x) throws SQLException {
        setFloat(getNamedParamIndex(parameterName, false), x);
    }

    private void setInOutParamsOnServer() throws SQLException {
        if (this.paramInfo.numParameters > 0) {
            int parameterIndex = 0;
            Iterator paramIter = this.paramInfo.iterator();
            while (paramIter.hasNext()) {
                CallableStatementParam inParamInfo = (CallableStatementParam) paramIter.next();
                if (inParamInfo.isOut && inParamInfo.isIn) {
                    String inOutParameterName = mangleParameterName(inParamInfo.paramName);
                    StringBuffer queryBuf = new StringBuffer(4 + inOutParameterName.length() + 1 + 1);
                    queryBuf.append("SET ");
                    queryBuf.append(inOutParameterName);
                    queryBuf.append("=?");
                    PreparedStatement setPstmt = null;
                    try {
                        setPstmt = this.connection.clientPrepareStatement(queryBuf.toString());
                        byte[] parameterAsBytes = getBytesRepresentation(inParamInfo.index);
                        if (parameterAsBytes != null) {
                            if (parameterAsBytes.length > 8 && parameterAsBytes[0] == 95 && parameterAsBytes[1] == 98 && parameterAsBytes[2] == 105 && parameterAsBytes[3] == 110 && parameterAsBytes[4] == 97 && parameterAsBytes[5] == 114 && parameterAsBytes[6] == 121 && parameterAsBytes[7] == 39) {
                                setPstmt.setBytesNoEscapeNoQuotes(1, parameterAsBytes);
                            } else {
                                int sqlType = inParamInfo.desiredJdbcType;
                                switch (sqlType) {
                                    case -7:
                                    case -4:
                                    case -3:
                                    case -2:
                                    case 2000:
                                    case 2004:
                                        setPstmt.setBytes(1, parameterAsBytes);
                                        break;
                                    default:
                                        setPstmt.setBytesNoEscape(1, parameterAsBytes);
                                        break;
                                }
                            }
                        } else {
                            setPstmt.setNull(1, 0);
                        }
                        setPstmt.executeUpdate();
                        if (setPstmt != null) {
                            setPstmt.close();
                        }
                    } catch (Throwable th) {
                        if (setPstmt != null) {
                            setPstmt.close();
                        }
                        throw th;
                    }
                }
                parameterIndex++;
            }
        }
    }

    @Override // java.sql.CallableStatement
    public void setInt(String parameterName, int x) throws SQLException {
        setInt(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setLong(String parameterName, long x) throws SQLException {
        setLong(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setNull(String parameterName, int sqlType) throws SQLException {
        setNull(getNamedParamIndex(parameterName, false), sqlType);
    }

    @Override // java.sql.CallableStatement
    public void setNull(String parameterName, int sqlType, String typeName) throws SQLException {
        setNull(getNamedParamIndex(parameterName, false), sqlType, typeName);
    }

    @Override // java.sql.CallableStatement
    public void setObject(String parameterName, Object x) throws SQLException {
        setObject(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setObject(String parameterName, Object x, int targetSqlType) throws SQLException {
        setObject(getNamedParamIndex(parameterName, false), x, targetSqlType);
    }

    @Override // java.sql.CallableStatement
    public void setObject(String parameterName, Object x, int targetSqlType, int scale) throws SQLException {
    }

    private void setOutParams() throws SQLException {
        int i;
        if (this.paramInfo.numParameters > 0) {
            Iterator paramIter = this.paramInfo.iterator();
            while (paramIter.hasNext()) {
                CallableStatementParam outParamInfo = (CallableStatementParam) paramIter.next();
                if (!this.callingStoredFunction && outParamInfo.isOut) {
                    String outParameterName = mangleParameterName(outParamInfo.paramName);
                    if (this.placeholderToParameterIndexMap == null) {
                        i = outParamInfo.index + 1;
                    } else {
                        i = this.placeholderToParameterIndexMap[outParamInfo.index - 1];
                    }
                    int outParamIndex = i;
                    setBytesNoEscapeNoQuotes(outParamIndex, StringUtils.getBytes(outParameterName, this.charConverter, this.charEncoding, this.connection.getServerCharacterEncoding(), this.connection.parserKnowsUnicode()));
                }
            }
        }
    }

    @Override // java.sql.CallableStatement
    public void setShort(String parameterName, short x) throws SQLException {
        setShort(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setString(String parameterName, String x) throws SQLException {
        setString(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setTime(String parameterName, Time x) throws SQLException {
        setTime(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setTime(String parameterName, Time x, Calendar cal) throws SQLException {
        setTime(getNamedParamIndex(parameterName, false), x, cal);
    }

    @Override // java.sql.CallableStatement
    public void setTimestamp(String parameterName, Timestamp x) throws SQLException {
        setTimestamp(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setTimestamp(String parameterName, Timestamp x, Calendar cal) throws SQLException {
        setTimestamp(getNamedParamIndex(parameterName, false), x, cal);
    }

    @Override // java.sql.CallableStatement
    public void setURL(String parameterName, URL val) throws SQLException {
        setURL(getNamedParamIndex(parameterName, false), val);
    }

    @Override // java.sql.CallableStatement
    public synchronized boolean wasNull() throws SQLException {
        return this.outputParamWasNull;
    }

    @Override // com.mysql.jdbc.PreparedStatement, com.mysql.jdbc.StatementImpl, java.sql.Statement
    public int[] executeBatch() throws SQLException {
        if (this.hasOutputParams) {
            throw SQLError.createSQLException("Can't call executeBatch() on CallableStatement with OUTPUT parameters", SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        return super.executeBatch();
    }

    /* JADX INFO: Access modifiers changed from: protected */
    @Override // com.mysql.jdbc.PreparedStatement
    public int getParameterIndexOffset() {
        if (this.callingStoredFunction) {
            return -1;
        }
        return super.getParameterIndexOffset();
    }

    @Override // java.sql.CallableStatement
    public void setAsciiStream(String parameterName, InputStream x) throws SQLException {
        setAsciiStream(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setAsciiStream(String parameterName, InputStream x, long length) throws SQLException {
        setAsciiStream(getNamedParamIndex(parameterName, false), x, length);
    }

    @Override // java.sql.CallableStatement
    public void setBinaryStream(String parameterName, InputStream x) throws SQLException {
        setBinaryStream(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setBinaryStream(String parameterName, InputStream x, long length) throws SQLException {
        setBinaryStream(getNamedParamIndex(parameterName, false), x, length);
    }

    @Override // java.sql.CallableStatement
    public void setBlob(String parameterName, java.sql.Blob x) throws SQLException {
        setBlob(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setBlob(String parameterName, InputStream inputStream) throws SQLException {
        setBlob(getNamedParamIndex(parameterName, false), inputStream);
    }

    @Override // java.sql.CallableStatement
    public void setBlob(String parameterName, InputStream inputStream, long length) throws SQLException {
        setBlob(getNamedParamIndex(parameterName, false), inputStream, length);
    }

    @Override // java.sql.CallableStatement
    public void setCharacterStream(String parameterName, Reader reader) throws SQLException {
        setCharacterStream(getNamedParamIndex(parameterName, false), reader);
    }

    @Override // java.sql.CallableStatement
    public void setCharacterStream(String parameterName, Reader reader, long length) throws SQLException {
        setCharacterStream(getNamedParamIndex(parameterName, false), reader, length);
    }

    @Override // java.sql.CallableStatement
    public void setClob(String parameterName, java.sql.Clob x) throws SQLException {
        setClob(getNamedParamIndex(parameterName, false), x);
    }

    @Override // java.sql.CallableStatement
    public void setClob(String parameterName, Reader reader) throws SQLException {
        setClob(getNamedParamIndex(parameterName, false), reader);
    }

    @Override // java.sql.CallableStatement
    public void setClob(String parameterName, Reader reader, long length) throws SQLException {
        setClob(getNamedParamIndex(parameterName, false), reader, length);
    }

    @Override // java.sql.CallableStatement
    public void setNCharacterStream(String parameterName, Reader value) throws SQLException {
        setNCharacterStream(getNamedParamIndex(parameterName, false), value);
    }

    @Override // java.sql.CallableStatement
    public void setNCharacterStream(String parameterName, Reader value, long length) throws SQLException {
        setNCharacterStream(getNamedParamIndex(parameterName, false), value, length);
    }
}
